
//
//  Created by Javier Flores Font on 11/01/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "FirstWindow.h"
#import "SecondWindow.h"
#import "IASKSpecifier.h"
#import "IASKSettingsReader.h"
#import "ServerTableController.h"

#import "CustomViewCell.h"

#define SCROLLVIEW_CONTENT_HEIGHT 460
#define SCROLLVIEW_CONTENT_WIDTH  320

BOOL primeravez=true;


@implementation FirstWindow


@synthesize buttonStartConnect,Ip,Name,passwordField,label;
@synthesize appSettingsViewController,scrollview;


- (IASKAppSettingsViewController*)appSettingsViewController {
	if (!appSettingsViewController) {
		appSettingsViewController = [[IASKAppSettingsViewController alloc] initWithNibName:@"IASKAppSettingsView" bundle:nil];
		appSettingsViewController.delegate = self;
	}
	return appSettingsViewController;
}


- (IBAction)showSettingsModal:(id)sender {
    UINavigationController *aNavController = [[UINavigationController alloc] initWithRootViewController:self.appSettingsViewController];
    //[viewController setShowCreditsFooter:NO];   // Uncomment to not display InAppSettingsKit credits for creators.
    // But we encourage you not to uncomment. Thank you!
    self.appSettingsViewController.showDoneButton = YES;
    [self presentModalViewController:aNavController animated:YES];
    [aNavController release];
}


#pragma mark -
#pragma mark IASKAppSettingsViewControllerDelegate protocol
- (void)settingsViewControllerDidEnd:(IASKAppSettingsViewController*)sender {
    [self dismissModalViewControllerAnimated:YES];
	
	// your code here to reconfigure the app for changed settings
}

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderForKey:(NSString*)key {
	if ([key isEqualToString:@"IASKLogo"]) {
		return [UIImage imageNamed:@"Icon.png"].size.height + 25;
	}
	return 0;
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderForKey:(NSString*)key {
	if ([key isEqualToString:@"IASKLogo"]) {
		UIImageView *imageView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"essh57.png"]];
		imageView.contentMode = UIViewContentModeCenter;
		return [imageView autorelease];
	}
	return nil;
}

- (CGFloat)tableView:(UITableView*)tableView heightForSpecifier:(IASKSpecifier*)specifier {
	if ([specifier.key isEqualToString:@"customCell"]) {
		return 44*3;
	}
	return 0;
}

- (UITableViewCell*)tableView:(UITableView*)tableView cellForSpecifier:(IASKSpecifier*)specifier {
	CustomViewCell *cell = (CustomViewCell*)[tableView dequeueReusableCellWithIdentifier:specifier.key];
	
	if (!cell) {
		cell = (CustomViewCell*)[[[NSBundle mainBundle] loadNibNamed:@"CustomViewCell" 
															   owner:self 
															 options:nil] objectAtIndex:0];
	}
	cell.textView.text= [[NSUserDefaults standardUserDefaults] objectForKey:specifier.key] != nil ? 
    [[NSUserDefaults standardUserDefaults] objectForKey:specifier.key] : [specifier defaultStringValue];
	cell.textView.delegate = self;
	[cell setNeedsLayout];
	return cell;
}

#pragma mark UITextViewDelegate (for CustomViewCell)
- (void)textViewDidChange:(UITextView *)textView {
    [[NSUserDefaults standardUserDefaults] setObject:textView.text forKey:@"customCell"];
    [[NSNotificationCenter defaultCenter] postNotificationName:kIASKAppSettingChanged object:@"customCell"];
}

#pragma mark -
- (void)settingsViewController:(IASKAppSettingsViewController*)sender buttonTappedForKey:(NSString*)key {
	if ([key isEqualToString:@"ButtonDemoAction1"]) {
		UIAlertView *alert = [[[UIAlertView alloc] initWithTitle:@"Demo Action 1 called" message:nil delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil] autorelease];
		[alert show];
	} else {
		UIAlertView *alert = [[[UIAlertView alloc] initWithTitle:@"Demo Action 2 called" message:nil delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil] autorelease];
		[alert show];
	}
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (IBAction) ConnectbySSH
{
    NSString *localPath1 = @"Documents/my1.archive";
    NSString *fullPath1 = [NSHomeDirectory() stringByAppendingPathComponent:localPath1];
    [NSKeyedArchiver archiveRootObject:Ip toFile:fullPath1];
    
    
    NSString *localPath2 = @"Documents/my2.archive";
    NSString *fullPath2 = [NSHomeDirectory() stringByAppendingPathComponent:localPath2];
	[NSKeyedArchiver archiveRootObject:Name toFile:fullPath2];
    
    NSString *localPath3 = @"Documents/my3.archive";
    NSString *fullPath3 = [NSHomeDirectory() stringByAppendingPathComponent:localPath3];
	[NSKeyedArchiver archiveRootObject:passwordField toFile:fullPath3];
	
    //[self.navigationController setNavigationBarHidden:NO];
    
    
    sshConnection1 = [[SSHConnection alloc] init];
    int x;
    
    x=[sshConnection1 connectToHost:Ip.text port:22 user:Name.text password:passwordField.text];
    
    if(x==0) [sshConnection1 closeConnection];
    //[sshConnection connectToHost:@"84.124.127.228" port:22 user:@"root" password:@"tr4sg0x"];
    
    if(x==-1){
        
        UIAlertView *progressAlert = [[UIAlertView alloc] initWithTitle: @"Connection failed"
                                                                message: @"Try other server."
                                                               delegate: self
                                                      cancelButtonTitle: @"Ok"
                                                      otherButtonTitles: nil];
        
        
        
        [progressAlert show];
        [progressAlert release];
       
        
        
    }
    else {


	
	SecondWindow *controller = [SecondWindow alloc];
    
    [[self navigationController] pushViewController:controller
                                           animated:YES];
    [controller release];
    }
	
}

- (IBAction) ManageServers
{
    NSString *localPath1 = @"Documents/my1.archive";
    NSString *fullPath1 = [NSHomeDirectory() stringByAppendingPathComponent:localPath1];
    [NSKeyedArchiver archiveRootObject:Ip toFile:fullPath1];
    
    
    NSString *localPath2 = @"Documents/my2.archive";
    NSString *fullPath2 = [NSHomeDirectory() stringByAppendingPathComponent:localPath2];
	[NSKeyedArchiver archiveRootObject:Name toFile:fullPath2];
    
    NSString *localPath3 = @"Documents/my3.archive";
    NSString *fullPath3 = [NSHomeDirectory() stringByAppendingPathComponent:localPath3];
	[NSKeyedArchiver archiveRootObject:passwordField toFile:fullPath3];
    
    
    ServerTableController *tableController = [[ServerTableController alloc] initWithStyle:UITableViewStylePlain];
	tableController.managedObjectContext = [self managedObjectContext];
    
    [[self navigationController] pushViewController:tableController
                                           animated:YES];

	[tableController release];
    

}


- (IBAction)keyboardOutIp:(id)sender

{
    
	[sender resignFirstResponder];
}

- (IBAction)keyboardOutName:(id)sender

{
	[sender resignFirstResponder];
}

- (IBAction)keyboardOutPass:(id)sender

{
	[sender resignFirstResponder];
}


- (void)encodeWithCoder:(NSCoder *)coder

{
	
    [coder encodeObject:Ip forKey:@"Ip"];
	
    [coder encodeObject:Name forKey:@"Name"];
	
    [coder encodeObject:passwordField forKey:@"passwordField"];
	
    
	
}

- (id)initWithCoder:(NSCoder *)coder

{
	
    Ip = [[coder decodeObjectForKey:@"Ip"] retain];
	
    Name = [[coder decodeObjectForKey:@"Name"] retain];
	
    passwordField = [[coder decodeObjectForKey:@"passwordField"] retain];
    
    return self;
	
}



/*
 // The designated initializer. Override to perform setup that is required before the view is loaded.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
 if (self) {
 // Custom initialization
 }
 return self;
 }
 */

/*
 // Implement loadView to create a view hierarchy programmatically, without using a nib.
 - (void)loadView {
 }
 */



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
    label.font=[UIFont fontWithName:@"Arial" size: 22.0];
    

    
    NSString *localPath1 = @"Documents/my1.archive";
    NSString *fullPath1 = [NSHomeDirectory() stringByAppendingPathComponent:localPath1];
    
    NSString *localPath2 = @"Documents/my2.archive";
    NSString *fullPath2 = [NSHomeDirectory() stringByAppendingPathComponent:localPath2];
    
    NSString *localPath3 = @"Documents/my3.archive";
    NSString *fullPath3 = [NSHomeDirectory() stringByAppendingPathComponent:localPath3];
    
    NSLog(@"VIEWDIDLOAD");
    
   UITextField *objetos1=[NSKeyedUnarchiver unarchiveObjectWithFile:fullPath1];
	UITextField *objetos2=[NSKeyedUnarchiver unarchiveObjectWithFile:fullPath2];
	UITextField *objetos3=[NSKeyedUnarchiver unarchiveObjectWithFile:fullPath3];
    
    

    
    
     Ip.text = objetos1.text;
	 Name.text=objetos2.text;
	 passwordField.secureTextEntry = YES;
	 passwordField.text=objetos3.text;
  
    /*

    [NSKeyedArchiver archiveRootObject:Ip toFile:fullPath1];

	[NSKeyedArchiver archiveRootObject:Name toFile:fullPath2];
 
	[NSKeyedArchiver archiveRootObject:passwordField toFile:fullPath3];
    
    */
    //NSLog(@"Ip:%@,User:%@,Pass:%@",Ip.text,Name.text,passwordField.text);
    
    //sshConnection1 = [[SSHConnection alloc] init];
  //  int conexion=[sshConnection1 connectToHost:Ip.text port:22 user:Name.text password:passwordField.text];
    
    //NSLog(@"conexion: %d",conexion);
    
    NSString *autoconectar = [[NSUserDefaults standardUserDefaults] stringForKey:@"toggleSwitch"];
    
    //NSLog(@"autoconectar = %@", autoconectar);
    if([autoconectar isEqualToString:@"1"]){
      
        [self.navigationController setNavigationBarHidden:NO];


    //if(conexion!=-1){
            
    SecondWindow *controller = [SecondWindow alloc];
    
    [[self navigationController] pushViewController:controller
                                           animated:YES];
    [controller release];
    //    }
        
    }
    
   /*
   
	Ip.text = @"84.124.127.228";
	Name.text=@"root";
	passwordField.secureTextEntry = YES;
	passwordField.text=@"tr4sg0x";
    
    */
   

}



-(void)viewWillAppear:(BOOL)animated{
    
    [super viewWillAppear:animated];
    
     if(primeravez==false){
    scrollview.frame = CGRectMake(0, 0, SCROLLVIEW_CONTENT_WIDTH, SCROLLVIEW_CONTENT_HEIGHT);
    NSLog(@"x: %f",offset.x);
    NSLog(@"y: %f",offset.y);
    
   
	offset.x=0;
    offset.y=50;;
	scrollview.contentOffset =offset;
     }
    primeravez=false;
  
    NSString *localPath1 = @"Documents/my4.archive";
    NSString *fullPath1 = [NSHomeDirectory() stringByAppendingPathComponent:localPath1];
    
    NSString *localPath2 = @"Documents/my5.archive";
    NSString *fullPath2 = [NSHomeDirectory() stringByAppendingPathComponent:localPath2];
    
    NSString *localPath3 = @"Documents/my6.archive";
    NSString *fullPath3 = [NSHomeDirectory() stringByAppendingPathComponent:localPath3];
    
     NSString *objetos1=[NSKeyedUnarchiver unarchiveObjectWithFile:fullPath1];
	 NSString *objetos2=[NSKeyedUnarchiver unarchiveObjectWithFile:fullPath2];
	 NSString *objetos3=[NSKeyedUnarchiver unarchiveObjectWithFile:fullPath3];
     NSLog(@"VIEW_WILL_APPEAR");
   
    
    
   
    Ip.text=objetos1;
    Name.text=objetos2;
    passwordField.text=objetos3;
    
    
    
    
	[[NSNotificationCenter defaultCenter] 
	 addObserver:self
	 selector:@selector
	 (keyboardDidShow:) 
	 name: UIKeyboardDidShowNotification
	 object:nil];
  
	[[NSNotificationCenter defaultCenter]
	 addObserver:self 
	 selector:@selector
	 (keyboardDidHide:) name:
	 UIKeyboardDidHideNotification
	 object:nil];
     
	
	scrollview.contentSize = CGSizeMake(SCROLLVIEW_CONTENT_WIDTH,
										SCROLLVIEW_CONTENT_HEIGHT);
    
    
 
	displayKeyboard = NO;
}


-(void) viewWillDisappear:(BOOL)animated {
	[[NSNotificationCenter defaultCenter]
	 removeObserver:self];
}

-(void) keyboardDidShow: (NSNotification *)notif {
    if (displayKeyboard) {
        return;
	}
	NSLog(@"KeyboardidSHOW");
	
	NSDictionary* info = [notif userInfo];
	NSValue* aValue = [info objectForKey:UIKeyboardBoundsUserInfoKey];
	CGSize keyboardSize = [aValue CGRectValue].size;
	
	offset = scrollview.contentOffset;
	
    CGRect viewFrame = scrollview.frame;
	viewFrame.size.height -= keyboardSize.height;
    scrollview.frame = viewFrame;
	
	//CGRect textFieldRect = [Field frame];
	//textFieldRect.origin.y += 10;
	//[scrollview scrollRectToVisible: textFieldRect animated:YES];
	displayKeyboard = YES;
}


-(void) keyboardDidHide: (NSNotification *)notif {
	if (!displayKeyboard) {
		return; 
	}
	
    NSLog(@"Keyboarddidhide");
	scrollview.frame = CGRectMake(0, 0, SCROLLVIEW_CONTENT_WIDTH, SCROLLVIEW_CONTENT_HEIGHT);
    NSLog(@"x: %f",offset.x);
     NSLog(@"y: %f",offset.y);
   
    
	offset.x=0;
    offset.y=50;;
	scrollview.contentOffset =offset;
	
    displayKeyboard = NO;
}




/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    self.appSettingsViewController = nil;
    
    
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [appSettingsViewController release];
	appSettingsViewController = nil;
    
    [managedObjectContext release];
    [managedObjectModel release];
    [persistentStoreCoordinator release];

    
    [super dealloc];
}
#pragma mark -
#pragma mark Core Data stack

/**
 Returns the managed object context for the application.
 If the context doesn't already exist, it is created and bound to the persistent store coordinator for the application.
 */
- (NSManagedObjectContext *) managedObjectContext {
	
    if (managedObjectContext != nil) {
        return managedObjectContext;
    }
	
    NSPersistentStoreCoordinator *coordinator = [self persistentStoreCoordinator];
    if (coordinator != nil) {
        managedObjectContext = [[NSManagedObjectContext alloc] init];
        [managedObjectContext setPersistentStoreCoordinator: coordinator];
    }
    return managedObjectContext;
}


/**
 Returns the managed object model for the application.
 If the model doesn't already exist, it is created by merging all of the models found in the application bundle.
 */
- (NSManagedObjectModel *)managedObjectModel {
	
    if (managedObjectModel != nil) {
        return managedObjectModel;
    }
    managedObjectModel = [[NSManagedObjectModel mergedModelFromBundles:nil] retain];    
    return managedObjectModel;
}


/**
 Returns the persistent store coordinator for the application.
 If the coordinator doesn't already exist, it is created and the application's store added to it.
 */
- (NSPersistentStoreCoordinator *)persistentStoreCoordinator {
	
    if (persistentStoreCoordinator != nil) {
        return persistentStoreCoordinator;
    }
	
    NSURL *storeUrl = [NSURL fileURLWithPath: [[self applicationDocumentsDirectory] stringByAppendingPathComponent: @"LapTimer.sqlite"]];
	
	NSError *error = nil;
    persistentStoreCoordinator = [[NSPersistentStoreCoordinator alloc] initWithManagedObjectModel:[self managedObjectModel]];
    if (![persistentStoreCoordinator addPersistentStoreWithType:NSSQLiteStoreType configuration:nil URL:storeUrl options:nil error:&error]) {
		/*
		 Replace this implementation with code to handle the error appropriately.
		 
		 abort() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development. If it is not possible to recover from the error, display an alert panel that instructs the user to quit the application by pressing the Home button.
		 
		 Typical reasons for an error here include:
		 * The persistent store is not accessible
		 * The schema for the persistent store is incompatible with current managed object model
		 Check the error message to determine what the actual problem was.
		 */
		NSLog(@"Unresolved error %@, %@", error, [error userInfo]);
		abort();
    }    
	
    return persistentStoreCoordinator;
}


#pragma mark -
#pragma mark Application's Documents directory

/**
 Returns the path to the application's Documents directory.
 */
- (NSString *)applicationDocumentsDirectory {
	return [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) lastObject];
}




@end
