//
//  SendMailViewController.m
//  SendMail
//
//  Created by Objective Coders LLC. on 12/29/10.
//

#import "SendMailViewController.h"

@implementation SendMailViewController

- (IBAction)sendMail {
	if ([MFMailComposeViewController canSendMail]) {
		MFMailComposeViewController *mfViewController = [[MFMailComposeViewController alloc] init];
		mfViewController.mailComposeDelegate = self;
		
		[self presentModalViewController:mfViewController animated:YES];
		[mfViewController release];
	}else {
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Status:" message:@"Your phone is not currently configured to send mail." delegate:nil cancelButtonTitle:@"ok" otherButtonTitles:nil];
		
		[alert show];
		[alert release];
	}
}

#pragma mark -
#pragma mark MFMailComposeViewControllerDelegate Methods

- (void)mailComposeController:(MFMailComposeViewController*)controller didFinishWithResult:(MFMailComposeResult)result error:(NSError*)error {
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Status:" message:@"" delegate:nil cancelButtonTitle:@"ok" otherButtonTitles:nil];
	
	switch (result) {
		case MFMailComposeResultCancelled:
			alert.message = @"Message Canceled";
			break;
		case MFMailComposeResultSaved:
			alert.message = @"Message Saved";
			break;
		case MFMailComposeResultSent:
			alert.message = @"Message Sent";
			break;
		case MFMailComposeResultFailed:
			alert.message = @"Message Failed";
			break;
		default:
			alert.message = @"Message Not Sent";
			break;	}
	[self dismissModalViewControllerAnimated:YES];
	
	[alert show];
	[alert release];
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
