//
//  TimeTableController.m
//  LapTimer
//
//  Created by Alex Eckermann on 2/05/10.
//  Created for MobTuts
//

#import "ServerTableController.h"



@implementation ServerTableController

@synthesize managedObjectContext, serverArray,Ip,Name,passwordField;

#pragma mark -
#pragma mark Initialization

/*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if ((self = [super initWithStyle:style])) {
    }
    return self;
}
*/


#pragma mark -
#pragma mark View lifecycle

- (void)viewDidLoad {
	[super viewDidLoad];
     [self.navigationController setNavigationBarHidden:NO];
	
	self.title = @"List";
    
	
	UIBarButtonItem *addButton = [[UIBarButtonItem alloc] initWithTitle:@"Add current" 
    style:UIBarButtonItemStylePlain target:self action:@selector(addServer:)];
	self.navigationItem.rightBarButtonItem = addButton;
	[addButton release];
    
    
    UIBarButtonItem *comeButton = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemCancel target:self action:@selector(comebackfirstmenu:)];
	self.navigationItem.backBarButtonItem = comeButton;
    
    
    
	[comeButton release];    
	
	[self fetchRecords];
	
}

- (void)addServer:(id)sender {
	
	
	
    NSString *localPath1 = @"Documents/my1.archive";
    NSString *fullPath1 = [NSHomeDirectory() stringByAppendingPathComponent:localPath1];
    
    NSString *localPath2 = @"Documents/my2.archive";
    NSString *fullPath2 = [NSHomeDirectory() stringByAppendingPathComponent:localPath2];
    
    NSString *localPath3 = @"Documents/my3.archive";
    NSString *fullPath3 = [NSHomeDirectory() stringByAppendingPathComponent:localPath3];
    
    
    
    UITextField *objetos1=[NSKeyedUnarchiver unarchiveObjectWithFile:fullPath1];
	UITextField *objetos2=[NSKeyedUnarchiver unarchiveObjectWithFile:fullPath2];
	UITextField *objetos3=[NSKeyedUnarchiver unarchiveObjectWithFile:fullPath3];
    
    NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription entityForName:@"EServer" inManagedObjectContext:managedObjectContext];
    [fetchRequest setEntity:entity];
    
    NSError *error;
    NSArray *items = [managedObjectContext executeFetchRequest:fetchRequest error:&error];
    [fetchRequest release];
        
    bool controlador=FALSE;
    int numelem=0;
    for (NSManagedObject *managedObject in items) {
        numelem++;
    
        NSString *x= [managedObject valueForKey:@"kIp"];
        if([objetos1.text isEqualToString:x]){
           
        
        NSString *x1= [managedObject valueForKey:@"kUser"];
        if([objetos2.text isEqualToString:x1])
            controlador=TRUE;
        }
    }
    if(objetos1.text==nil || objetos2.text==nil  || objetos3.text==nil || [objetos1.text isEqualToString:@""] || [objetos2.text isEqualToString:@""] ||  [objetos3.text isEqualToString:@""]  )
        controlador=TRUE;
    
    if(controlador==FALSE){
        EServer *server = (EServer *)[NSEntityDescription insertNewObjectForEntityForName:@"EServer" inManagedObjectContext:managedObjectContext];
    [server setKIp:objetos1.text];
    [server setKUser:objetos2.text];
    [server setKPass:objetos3.text];
	
	
	if (![managedObjectContext save:&error]) {
		// This is a serious error saying the record could not be saved.
		// Advise the user to restart the application
	}
	
        //NSLog(@"%d",numelem);
        
        
       
        
	[serverArray insertObject:server atIndex:numelem];
	[self.tableView reloadData];
    }
    else {
        
        
        UIAlertView *progressAlert = [[UIAlertView alloc] initWithTitle: @"Error"
                                                                message: @"Host already exist or maybe there are a field empty. Please in the main Window insert a valid connection."
                                                               delegate: self
                                                      cancelButtonTitle: @"Close message"
                                                      otherButtonTitles: nil];
        
        
        // Create the progress bar and add it to the alert
        
        [progressAlert show];
        [progressAlert release];
    }
    
	
}

- (void) deleteAllObjects: (id) sender {
    NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription entityForName:@"EServer" inManagedObjectContext:managedObjectContext];
    [fetchRequest setEntity:entity];
    
    NSError *error;
    NSArray *items = [managedObjectContext executeFetchRequest:fetchRequest error:&error];
    [fetchRequest release];
    
    
    for (NSManagedObject *managedObject in items) {
        
        [managedObjectContext deleteObject:managedObject];
       
    }
    if (![managedObjectContext save:&error]) {
        NSLog(@"Error");
    }
    [self.tableView reloadData];
    

}

- (void)comebackfirstmenu:(id)sender {
    [self.navigationController setNavigationBarHidden:NO];
	[[self navigationController]popToRootViewControllerAnimated:YES];
}

- (void)fetchRecords {
	
	// Define our table/entity to use
	NSEntityDescription *entity = [NSEntityDescription entityForName:@"EServer" inManagedObjectContext:managedObjectContext];
	
	// Setup the fetch request
	NSFetchRequest *request = [[NSFetchRequest alloc] init];
	[request setEntity:entity];
/*	
	// Define how we will sort the records
	NSSortDescriptor *sortDescriptor = [[NSSortDescriptor alloc] initWithKey:@"kIp" ascending:NO];
	NSArray *sortDescriptors = [NSArray arrayWithObject:sortDescriptor];
	
	[request setSortDescriptors:sortDescriptors];
	[sortDescriptor release];
*/	
	// Fetch the records and handle an error
	NSError *error;
	NSMutableArray *mutableFetchResults = [[managedObjectContext executeFetchRequest:request error:&error] mutableCopy];
	
	if (!mutableFetchResults) {
		// Handle the error.
		// This is a serious error and should advise the user to restart the application
	}
	
	// Save our fetched data to an array
	[self setServerArray: mutableFetchResults];
	
	[mutableFetchResults release];
	[request release];
	
}

/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
}
*/
/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


#pragma mark -
#pragma mark Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    // Return the number of sections.
    return 1;
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // Return the number of rows in the section.
    return [serverArray count];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
	static NSString *CellIdentifier = @"Cell";
	
	
	
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:CellIdentifier] autorelease];
	}
	
	EServer *server = [serverArray objectAtIndex: [indexPath row]];
	EServer *previousServer = nil;
	if ([serverArray count] > ([indexPath row] + 1)) {
		previousServer = [serverArray objectAtIndex: ([indexPath row] + 1)];
	}
    
    
    
	
	
    NSString *myString =@"Host: " ;
    NSString *test1 = [myString stringByAppendingString:server.kIp];
    NSString *test2 = [test1 stringByAppendingString:@"   User: "];
    NSString *test3 = [test2 stringByAppendingString:server.kUser];
	[cell.textLabel setText: test3];

    sshConnection2 = [[SSHConnection alloc] init];
    int x;
    
    x=[sshConnection2 connectToHost:server.kIp port:22 user:server.kUser password:server.kPass];
    
    if(x==0) [sshConnection2 closeConnection];
    //[sshConnection connectToHost:@"84.124.127.228" port:22 user:@"root" password:@"tr4sg0x"];
    
    if(x==-1){
        
        cell.textLabel.textColor=[UIColor colorWithRed:1 green:0 blue:0 alpha:1.0];        
        
        
    }
    else {
        cell.textLabel.textColor=[UIColor colorWithRed:0 green:1 blue:0 alpha:1.0];
        
    }

	return cell;
	
}


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


#pragma mark -
#pragma mark Table view delegate





- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
  
   
    int row = indexPath.row;
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    NSLog(@"fila seleccionada: %d",row); 
    
    
    NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription entityForName:@"EServer" inManagedObjectContext:managedObjectContext];
    [fetchRequest setEntity:entity];
    
    NSError *error;
    NSArray *items = [managedObjectContext executeFetchRequest:fetchRequest error:&error];
    [fetchRequest release];
    
    int i=0;
    for (NSManagedObject *managedObject in items) {
        
        if(i==row){
            NSString *x = [[NSString alloc]init];

            NSString *x1 = [[NSString alloc]init];

            NSString *x2 = [[NSString alloc]init];

            x= [managedObject valueForKey:@"kIp"];
            x1= [managedObject valueForKey:@"kUser"];
            x2= [managedObject valueForKey:@"kPass"];
            
             NSLog(@"%@",x);
             NSLog(@"%@",x1);
             NSLog(@"%@",x2);
         /*   
            passwordField.text=x2;
            Ip.text=@"asselya";
            Name.text=x1;
*/
           
            
            NSString *localPath1 = @"Documents/my4.archive";
            NSString *fullPath1 = [NSHomeDirectory() stringByAppendingPathComponent:localPath1];
            [NSKeyedArchiver archiveRootObject:x toFile:fullPath1];
             NSLog(@"ip: %@",x);
            
            
            NSString *localPath2 = @"Documents/my5.archive";
            NSString *fullPath2 = [NSHomeDirectory() stringByAppendingPathComponent:localPath2];
            [NSKeyedArchiver archiveRootObject:x1 toFile:fullPath2];
             NSLog(@"%@",x1);
            
            NSString *localPath3 = @"Documents/my6.archive";
            NSString *fullPath3 = [NSHomeDirectory() stringByAppendingPathComponent:localPath3];
            [NSKeyedArchiver archiveRootObject:x2 toFile:fullPath3];
             NSLog(@"%@",x2);

            
            
        }
        
            i++;
        
    }
    
    
    
    
    [[self navigationController]popToRootViewControllerAnimated:YES];
    
}


#pragma mark -
#pragma mark Memory management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}


- (void)dealloc {
	
	[managedObjectContext release];
	[serverArray release];
	
    [super dealloc];
}


- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
  
    //[self.tableView deleteRowsAtIndexPaths:index withRowAnimation: UITableViewRowAnimationNone];
    
    
   
     NSUInteger row = [indexPath row];
    
    
    
    
    EServer *server = [serverArray objectAtIndex: [indexPath row]];
    

    
    //delete from database
      NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
      NSEntityDescription *entity = [NSEntityDescription entityForName:@"EServer" inManagedObjectContext:managedObjectContext];
      [fetchRequest setEntity:entity];
      
      NSError *error;
      NSArray *items = [managedObjectContext executeFetchRequest:fetchRequest error:&error];
      [fetchRequest release];
      

    
   // NSLog(@"BASE DE DATOS:  ");
      for (NSManagedObject *managedObject in items) {
        //  NSLog(@" -OBJETO:%@", [managedObject valueForKey:@"kIp"]);
          if([[managedObject valueForKey:@"kIp"]  isEqualToString:server.kIp] &&
             [[managedObject valueForKey:@"kUser"]  isEqualToString:server.kUser]){
              [managedObjectContext deleteObject:managedObject];
          // NSLog(@", borrado.");   
          }
              
      }
    
    
         
    
   // NSLog(@"SERVERARRAY: numelem %@  ",[serverArray count]);
    
    //for(int i=0;i<[serverArray count];i++)
      //      NSLog(@"server: %@",[[serverArray objectAtIndex:i] valueForKey:@"kIp"] );
    
    //delete from serverarray
    
   // NSLog(@"fila: %d",row);
    [serverArray removeObjectAtIndex:row];
    
    
    if (![managedObjectContext save:&error]) {
        NSLog(@"Error");
    }
    
    [tableView reloadData];

    
}


@end

